/* @source seqretset application
**
** Read and write sequences as a set
**
** @author Copyright (C) Peter Rice
** @@
**
** This program is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License
** as published by the Free Software Foundation; either version 2
** of the License, or (at your option) any later version.
**
** This program is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this program; if not, write to the Free Software
** Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
******************************************************************************/

#include "emboss.h"




/* @prog nthseqset *********************************************************
**
** Reads and writes (returns) one set from input containing multiple sets
** of sequences
**
******************************************************************************/

int main(int argc, char **argv)
{
    AjPSeqset* seqsets;
    AjPSeqout seqout;
    ajint n;
    ajint count = 0;
    ajuint i;

    embInit("nthseqset", argc, argv);

    seqsets = ajAcdGetSeqsetall("sequence");
    n      = ajAcdGetInt("number");
    seqout = ajAcdGetSeqoutall("outseq");

    while(seqsets[count])
        count++;

    if(count < n)
    {
	ajSeqoutClose(seqout);
	ajFatal("No such sequence set - only %d sequence sets were input.",
                count);
	embExitBad();
    }

    ajSeqoutWriteSet(seqout, seqsets[n-1]);
    ajSeqoutClose(seqout);

    for(i=0;seqsets[i];i++)
        ajSeqsetDel(&seqsets[i]);
    AJFREE(seqsets);
    ajSeqoutDel(&seqout);

    embExit();

    return 0;
}
